GGJ.Preloader = function (game) {
	this.background = null;
	this.preloadBar = null;
};
GGJ.Preloader.prototype = {
	init:function(){
		this.game.antialias = false; 
	},
	preload: function () {
		this.background = this.add.sprite(this.world.centerX-150, (this.world.height*0.5)-3, 'fondoBarraPrecarga');
		this.preloadBar = this.add.sprite(this.world.centerX-150, (this.world.height*0.5)-3, 'barraPrecarga');
		this.load.setPreloadSprite(this.preloadBar);

		this.load.bitmapFont('fuente-normal', 'assets/fonts/normal.png', 'assets/fonts/normal.xml');
		this.load.bitmapFont('fuente-comentarios', 'assets/fonts/comentarios.png', 'assets/fonts/comentarios.xml');

		this.load.image("boton-play", "assets/img/botonPlay.png");
		this.load.image("boton-top", "assets/img/boton-top.png");
		this.load.image("boton-instructions", "assets/img/boton-instructions.png");
		this.load.image("boton-repetir", "assets/img/boton-repetir.png");
		this.load.image("boton-twitter", "assets/img/boton-twitter.png");
		this.load.image("boton-save", "assets/img/boton-save.png");
		this.load.image("boton-menu", "assets/img/boton-menu.png");
		this.load.spritesheet("boton-musica", "assets/img/boton-musica.png", 80, 80)
		this.load.spritesheet("boton-sonido", "assets/img/boton-sonido.png", 80, 80)

		this.load.image("suelo", "assets/img/suelo.gif")
		this.load.image("papa", "assets/img/papa.png")
		this.load.image("cabeza", "assets/img/cabeza.png")
		this.load.spritesheet("prota", "assets/img/prota.png", 100, 78)
		this.load.image("pared-izquierda", "assets/img/pared-izquierda.gif")
		this.load.image("pared-derecha", "assets/img/pared-derecha.gif")
		this.load.image("martillo", "assets/img/martillo.png")
		this.load.image("bocadillo", "assets/img/bocadillo.png")
		this.load.spritesheet("bomba-humo", "assets/img/bomba-humo.png", 50, 50)
		this.load.spritesheet("bala-papa", "assets/img/bala-papa.png", 30, 31)
		this.load.image("agua-bendita", "assets/img/agua-bendita.png")
		this.load.spritesheet("hammertime", "assets/img/hammertime.png", 100, 100)

		this.load.image("leadersboard-fondo", "assets/img/leadersboard-fondo.png")
		this.load.image("leadersboard-new-record", "assets/img/leadersboard-new-record.png")
		this.game.load.image("borde-iniciales", "assets/img/borde-iniciales.png");
		this.game.load.image("marcador-arriba", "assets/img/marcador-arriba.png");
		this.game.load.image("marcador-abajo", "assets/img/marcador-abajo.png");
		this.load.spritesheet("corazones", "assets/img/corazones.png", 72, 22)

		this.load.spritesheet("pajaro", "assets/img/pajaro.png", 30, 21)
		this.load.spritesheet("bola-pajaro", "assets/img/bola-pajaro.png", 5, 5)

		this.load.atlas('arcade', 'assets/joystick/arcade-joystick.png', 'assets/joystick/arcade-joystick.json');


		this.load.audio('bso', ['assets/bso/bso.mp3', 'assets/bso/bso.ogg']);
		this.load.audio('hammertime', ['assets/fx/hammertime.mp3', 'assets/fx/hammertime.ogg']);
		this.load.audio('impacto_recibido', ['assets/fx/impacto_recibido.mp3', 'assets/fx/impacto_recibido.ogg']);
		this.load.audio('disparo_enemigo', ['assets/fx/disparo_enemigo.mp3', 'assets/fx/disparo_enemigo.ogg']);
		this.load.audio('disparo', ['assets/fx/disparo.mp3', 'assets/fx/disparo.ogg']);



		this.game.sound.setDecodedCallback([
			'bso',
			'hammertime',
			'impacto_recibido',
			'disparo_enemigo',
			'disparo'
			], this.empezar, this);
	},
	empezar:function(){
		
		this.state.start("Intro")
		//this.state.start("Instructions")
	}
};
