OldschoolInput = function (game, tipografia, tamanio, posX, posY, raiz, textura,  texturaLetraActiva, offsetX, offsetY, texturaMarcadorArriba, texturaMarcadorAbajo, separacionMarcadores, texturaBotonGrabar, posicionBotonGrabar) {
    Phaser.Sprite.call(this, game, posX, posY);
    this.game = game;
    this.raiz = raiz;

    this.fondo = game.add.sprite(posX, posY, textura)
    this.fondo.anchor.setTo(0.5)

    this.arrayCaracteres=["A","B","C","D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", ".", "#", "&", "!", "(", ")"]
    this.indiceLetra1=0;
    this.indiceLetra2=0;
    this.indiceLetra3=0;

    this.letra1 = game.add.bitmapText(posX-(tamanio)+offsetX, posY+offsetY, tipografia, "A", tamanio);
    this.letra2 = game.add.bitmapText(posX+offsetX, posY+offsetY, tipografia, "A", tamanio);
    this.letra3 = game.add.bitmapText(posX+(tamanio)+offsetX, posY+offsetY, tipografia, "A", tamanio);    

    for(var i=1;i<=3;i++){
        this["letra"+i].anchor.setTo(0.5, 1.1)
        this["letra"+i].name = "letra"+i;
        this["letra"+i].inputEnabled = true;
        this["letra"+i].input.useHandCursor=true;
        this["letra"+i].events.onInputDown.add(this.colocaMarcador, this);
    }

    this.letraActiva = this.letra1;
    this.animacionLetraActiva = game.add.tween(this.letra1).to({ alpha: .33 }, 250, "Linear", true, 0, -1)
    this.animacionLetraActiva.yoyo(true, 250)

    this.marcadorLetraActiva = game.add.sprite(this.letraActiva.x-2, this.letraActiva.y-35, texturaLetraActiva)
    this.marcadorLetraActiva.anchor.setTo(0.5)

    this.marcadorArriba = game.add.sprite(this.letraActiva.x-2, this.letraActiva.y - separacionMarcadores-45, texturaMarcadorArriba)
    this.marcadorArriba.anchor.setTo(0.5);
    this.marcadorArriba.inputEnabled=true;
    this.marcadorArriba.input.useHandCursor=true;
    this.marcadorArriba.events.onInputDown.add(this.cambiaLetraActiva, this)

    this.marcadorAbajo = game.add.sprite(this.letraActiva.x, this.letraActiva.y + separacionMarcadores-25, texturaMarcadorAbajo)
    this.marcadorAbajo.anchor.setTo(0.5);
    this.marcadorAbajo.inputEnabled=true;
    this.marcadorAbajo.input.useHandCursor=true;
    this.marcadorAbajo.events.onInputDown.add(this.cambiaLetraActiva, this)

    this.botonGrabar = game.add.sprite(posicionBotonGrabar.x, posicionBotonGrabar.y, texturaBotonGrabar);
    this.botonGrabar.anchor.setTo(0.5);
    this.botonGrabar.inputEnabled=true;
    this.botonGrabar.input.useHandCursor=true;
    this.botonGrabar.events.onInputDown.add(this.grabaNombre, this)
    //console.log(this.letra1)
       
};

OldschoolInput.prototype = Object.create(Phaser.Sprite.prototype);
OldschoolInput.prototype.constructor = OldschoolInput;
OldschoolInput.prototype.colocaMarcador = function(cual){
    //console.log(cual)
    this.animacionLetraActiva.stop();
    this.animacionLetraActiva = null;

    if(cual.name=="letra1"){
        this.letraActiva=this.letra1;
        this.letra2.alpha=1;
        this.letra3.alpha=1;
        animacion1 = this.game.add.tween(this.marcadorArriba).to({x:this.letra1.x}, 500, Phaser.Easing.Elastic.Out, true);
        animacion2 = this.game.add.tween(this.marcadorLetraActiva).to({x:this.letra1.x}, 500, Phaser.Easing.Elastic.Out, true, 250);
        animacion3 = this.game.add.tween(this.marcadorAbajo).to({x:this.letra1.x}, 500, Phaser.Easing.Elastic.Out, true, 500);

        this.animacionLetraActiva = this.game.add.tween(this.letra1).to({ alpha: .33 }, 250, "Linear", true, 0, -1)
        this.animacionLetraActiva.yoyo(true, 250)

    }else if(cual.name=="letra2"){
        this.letra1.alpha=1;
        this.letra3.alpha=1;
        this.letraActiva=this.letra2;
        animacion1 = this.game.add.tween(this.marcadorArriba).to({x:this.letra2.x}, 500, Phaser.Easing.Elastic.Out, true);
        animacion2 = this.game.add.tween(this.marcadorLetraActiva).to({x:this.letra2.x}, 500, Phaser.Easing.Elastic.Out, true, 250);
        animacion3 = this.game.add.tween(this.marcadorAbajo).to({x:this.letra2.x}, 500, Phaser.Easing.Elastic.Out, true, 500);

        this.animacionLetraActiva = this.game.add.tween(this.letra2).to({ alpha: .33 }, 250, "Linear", true, 0, -1)
        this.animacionLetraActiva.yoyo(true, 250)


    }else if(cual.name=="letra3"){
        this.letra1.alpha=1;
        this.letra2.alpha=1;
        this.letraActiva=this.letra3;
        animacion1 = this.game.add.tween(this.marcadorArriba).to({x:this.letra3.x}, 500, Phaser.Easing.Elastic.Out, true);
        animacion2 = this.game.add.tween(this.marcadorLetraActiva).to({x:this.letra3.x}, 500, Phaser.Easing.Elastic.Out, true, 250);
        animacion3 = this.game.add.tween(this.marcadorAbajo).to({x:this.letra3.x}, 500, Phaser.Easing.Elastic.Out, true, 500);

        this.animacionLetraActiva = this.game.add.tween(this.letra3).to({ alpha: .33 }, 250, "Linear", true, 0, -1)
        this.animacionLetraActiva.yoyo(true, 250)
    }
}
OldschoolInput.prototype.cambiaLetraActiva = function(cual){
    if(cual.key=="marcador-arriba"){
        direccion="arriba"
    }else{
        direccion="abajo"
    }


    if(this.letraActiva.name=="letra1"){
        if(direccion=="arriba"){
            this.indiceLetra1--;
            if(this.indiceLetra1<0){
                this.indiceLetra1=this.arrayCaracteres.length-1;
            }
        }else{
            this.indiceLetra1++;
            if(this.indiceLetra1>this.arrayCaracteres.length-1){
                this.indiceLetra1=0;
            }
        }
        this.letra1.setText(this.arrayCaracteres[this.indiceLetra1])
    }else if(this.letraActiva.name=="letra2"){
        if(direccion=="arriba"){
            this.indiceLetra2--;
            if(this.indiceLetra2<0){
                this.indiceLetra2=this.arrayCaracteres.length-1;
            }
        }else{
            this.indiceLetra2++;
            if(this.indiceLetra2>this.arrayCaracteres.length-1){
                this.indiceLetra2=0;
            }
        }
        this.letra2.setText(this.arrayCaracteres[this.indiceLetra2])
    }else if(this.letraActiva.name=="letra3"){
        if(direccion=="arriba"){
            this.indiceLetra3--;
            if(this.indiceLetra3<0){
                this.indiceLetra3=this.arrayCaracteres.length-1;
            }
        }else{
            this.indiceLetra3++;
            if(this.indiceLetra3>this.arrayCaracteres.length-1){
                this.indiceLetra3=0;
            }
        }
        this.letra3.setText(this.arrayCaracteres[this.indiceLetra3])
    }


}
OldschoolInput.prototype.grabaNombre = function() {
    var cadena = this.letra1.text+this.letra2.text+this.letra3.text;
    this.raiz.enviaRecord(cadena);
    this.fondo.destroy();
    this.letra1.destroy();
    this.letra2.destroy();
    this.letra3.destroy();
    this.marcadorLetraActiva.destroy();
    this.marcadorArriba.destroy();
    this.marcadorAbajo.destroy();
    this.botonGrabar.destroy();
};
OldschoolInput.prototype.update = function() {
	//console.log(this.x)

    //this.angle += this.rotateSpeed;
};