GGJ.Game = function (game) { 
};

GGJ.Game.prototype = {
    init:function(){
        this.juegoActivo = true;
        this.tiempoIntervalo=1233;
        this.tiempoMovimiento=500;
        this.tiempoEntreDisparos=500;
        this.martillazos=0;
        this.pasosParaActualizar=0;
        this.pajarosEnPantalla=false;
        this.papaVulnerable = true;
        this.vidasRestantes=3;
        this.puedeDisparar=true;
        this.pasosEntreDisparosPapa=0;
        this.physics.startSystem(Phaser.Physics.ARCADE);
        this.suelo = this.game.add.tileSprite(0, 0, this.game.world.width, this.game.world.height, 'suelo');
        this.paredIzquierda = this.game.add.sprite(0, 0, "pared-izquierda")
        this.paredDerecha = this.game.add.sprite(this.world.width, 0, "pared-derecha")
        this.paredDerecha.anchor.setTo(1, 0)
        this.physics.enable(this.paredIzquierda)
        this.paredIzquierda.body.immovable = true;
        this.paredIzquierda.body.moves = false;
        this.paredIzquierda.body.allowGravity = false;
        
        this.physics.enable(this.paredDerecha)
        this.paredDerecha.body.immovable = true;
        this.paredDerecha.body.moves = false;
        this.paredDerecha.body.allowGravity = false;
        

        this.papa = this.game.add.sprite(this.world.centerX, this.world.height*0.25, "papa")
        this.papa.anchor.setTo(0.5)
        this.papa.scale.setTo(.65)
        this.physics.arcade.enable(this.papa)

        this.cabeza = this.game.add.sprite(this.papa.x, this.papa.y, "cabeza")
        this.cabeza.anchor.setTo(0.5, 1)
        this.cabeza.scale.setTo(.65)
        this.physics.arcade.enable(this.cabeza)
        this.cabeza.body.setSize(60, 80, 0, 0)

        this.prota = this.game.add.sprite(this.world.centerX, this.world.height*0.875, "prota")
        this.prota.anchor.setTo(0.5)
        this.prota.animations.add("izquierda", [1, 2, 3, 4, 5, 6, 7])
        this.prota.animations.add("derecha", [8, 9, 10, 11, 12, 13])
        this.physics.arcade.enable(this.prota)
        this.prota.body.setSize(25,25)
        this.prota.scale.setTo(0.6)

        
        this.initUI()
        this.initInput();
        this.initBalas();
        this.initBotellas();
        this.initMovimientoPapa();
        this.initMartillos();
        this.initAudios();
        this.initTiempo();

        this.hammertime = this.game.add.sprite(-500, 0, "hammertime");
        this.hammertime.anchor.setTo(0.5)
        this.hammertime.animations.add("baila", [0,1,2,3])
        //this.hammertime.animations.play("baila", 5, true)

        this.initJuicy();
    },
    initJuicy:function(){
        this.juicy=this.game.plugins.add(new Phaser.Plugin.Juicy(this));
        this.screenFlash=this.juicy.createScreenFlash();
        this.add.existing(this.screenFlash);
    },
    initUI:function(){
        this.corazonesArriba = this.game.add.sprite(this.world.centerX, 15, "corazones")
        this.corazonesArriba.anchor.setTo(0.5);
        this.corazonesArriba.scale.setTo(0.5);
        this.corazonesArriba.frame = this.vidasRestantes;

        this.corazonesAbajo = this.game.add.sprite(this.world.centerX, this.world.height-15, "corazones")
        this.corazonesAbajo.anchor.setTo(0.5);
        this.corazonesAbajo.scale.setTo(0.5);
        this.corazonesAbajo.frame = this.vidasRestantes;
    }, 
    initTiempo:function(){
        var fecha = new Date();
        this.momentoInicio = fecha.getTime();

        this.marcador = this.game.add.bitmapText(100, 10, "fuente-normal", "00:00", 28)


    },
    formateaTiempo:function(tiempo){
        x = tiempo / 1000
        segundos = Math.floor(x % 60)
        x /= 60
        minutos = Math.floor(x % 60)
        x /= 60
        horas = x % 24
        x /= 24
        días = x

        var cadenaMinutos;
        var cadenaSegundos;

        if(minutos>=1){
            if(minutos<10){
                cadenaMinutos = "0"+minutos;
            }else{
                cadenaMinutos = minutos;
            }           
        }else{
            cadenaMinutos = "00";
        }

        if(segundos>=1){
            if(segundos<10){
                cadenaSegundos = "0"+segundos;
            }else{
                cadenaSegundos = segundos;
            }           
        }else{
            cadenaSegundos = "00";
        }

        //console.log(segundos)
        return cadenaMinutos+":"+cadenaSegundos;
        
    },
    initAudios:function(){
        this.sonido_hammertime = this.game.add.audio("hammertime");
        this.sonido_impacto_recibido = this.game.add.audio("impacto_recibido");
        this.sonido_disparo_enemigo = this.game.add.audio("disparo_enemigo");
        this.sonido_disparo = this.game.add.audio("disparo");
        /*GGJ.bso = this.game.add.sound("bso", 0.25, true);*/
    },
    initBotellas:function(){
        this.grupoBotellas = this.game.add.group();
        for(var i=1; i<=10; i++){
            var botella = this.game.add.sprite(-500, 0, "agua-bendita")
            botella.alive=false;
            botella.anchor.setTo(0.5)
            this.physics.arcade.enable(botella)
            this.grupoBotellas.add(botella)
        }
    },
    initBolasPajaros:function(){
        this.grupoBolasPajaros = this.game.add.group();
        for(var i=1; i<=10; i++){
            //var bola = this.game.add.sprite(300, 100, "bola-pajaro")
            var bola = this.game.add.sprite(this.world.centerX, -50, "bala-papa")
            bola.scale.setTo(0.5)
            bola.alive=false;
            bola.animations.add("parpadea", [0,1])
            bola.anchor.setTo(0.5)
            this.physics.arcade.enable(bola)
            this.grupoBolasPajaros.add(bola)
        }
    },
    initBalas:function(){
        this.grupoBalas = this.game.add.group();
        for(var i=1; i<=10; i++){
            var bala = this.game.add.sprite(-500, 0, "bala-papa")
            bala.alive=false;
            bala.animations.add("parpadea", [0,1])
            bala.anchor.setTo(0.5)
            this.physics.arcade.enable(bala)
            this.grupoBalas.add(bala)
        }
    },
    initMartillos:function(){
        this.grupoMartillos = this.game.add.group();
        for(var i=1; i<=50; i++){
            var martillo = this.game.add.sprite(-500, 0, "martillo")
            martillo.alive=false;
            martillo.anchor.setTo(0.5)
            this.physics.arcade.enable(martillo)
            this.grupoMartillos.add(martillo)
        }
    },
    initMovimientoPapa:function(){
            this.timerPapa = this.game.time.create(true);
            this.eventotimerPapa = this.timerPapa.loop(this.tiempoIntervalo, function(){
                var papaTween = this.game.add.tween(this.papa).to({x:this.rnd.between(100, this.world.width-100)}, this.tiempoMovimiento, Phaser.Easing.Elastic.Out, true, 500)
                //this.papa.body.velocity.x = this.rnd.between(-500, 500)
                if(this.martillazos>0 && this.pasosEntreDisparosPapa==3 && this.papa.y > 0){
                    if(this.martillazos==1){
                        this.lanzaBala();
                    }else{
                        this.lanzaBotella();
                    }
                    this.pasosEntreDisparosPapa=0;
                }else{
                    this.pasosEntreDisparosPapa++;
                    if(this.pasosEntreDisparosPapa>3){
                        this.pasosEntreDisparosPapa=0;
                    }
                }
            }, this);
            this.timerPapa.start();
    },
    initPajaros:function(){
        this.grupoPajaros = this.game.add.group();
        for(var i=0; i<=5;i++){

            var pajaro = this.game.add.sprite(this.world.width*0.15, -50, "pajaro")
            pajaro.alive=false;
            pajaro.anchor.setTo(0.5)
            pajaro.animations.add("vuela", [0, 1, 2])
            this.physics.arcade.enable(pajaro)

            this.grupoPajaros.add(pajaro)
        }


        this.timerPajaros = this.game.time.create(true);
            this.eventotimerPajaros = this.timerPajaros.loop(1000, function(){
                var contador=1;
                this.grupoPajaros.forEachDead(function(pajaro){
                    pajaro.alive = true;
                    pajaro.animations.play("vuela", 10, true)
                    
                    this.time.events.add(contador*1000, function(){
                        pajaro.body.velocity.y = 15;
                    },this)

                    this.time.events.add(contador*this.rnd.between(2000, 5000), function(){
                        var bola = this.grupoBolasPajaros.getFirstDead();
                        if(bola){
                            bola.x = pajaro.x;
                            bola.y = pajaro.y;
                            bola.alive=true;
                            bola.animations.play("parpadea", 10, true);
                            this.physics.arcade.accelerateToObject(bola, this.prota, 50, 250, 250) 
                        }
                        
                    },this)

                    if(!this.pajarosEnPantalla){
                        var tweenPajaro = this.game.add.tween(pajaro).to({x:this.world.width*0.85}, 5000, Phaser.Easing.Quintic.InOut, true, contador*1000, false, -1)
                        tweenPajaro.yoyo(5000, true)
                    }
                    contador++;
                
                },this)
                
                
            }, this);
            
    },
    lanzaBala:function(){
        var bala = this.grupoBalas.getFirstDead();
        if(bala){
            bala.alive = true;
            bala.x = this.papa.x;
            bala.y = this.papa.y;
            bala.animations.play("parpadea", 15, true)
            this.physics.arcade.accelerateToObject(bala, this.prota, 200, 100, 100)
        }
        if(GGJ.haySonido){
            this.sonido_disparo_enemigo.play();
        }
    },
    lanzaBotella:function(){
        var botella = this.grupoBotellas.getFirstDead();
        if(botella){
            botella.alive = true;
            botella.x = this.papa.x;
            botella.y = this.papa.y;
            this.physics.arcade.accelerateToObject(botella, this.prota, 300, 100, 100)
            botella.body.angularVelocity = this.rnd.between(200, 300)
        }
        if(GGJ.haySonido){
            this.sonido_disparo_enemigo.play();
        } 
    },
    initInput:function(){
        if(this.game.device.desktop){
            this.izquierda = this.game.input.keyboard.addKey(Phaser.Keyboard.LEFT);
            this.derecha = this.game.input.keyboard.addKey(Phaser.Keyboard.RIGHT);
            this.espacio = this.game.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
            this.espacio.onDown.add(function(){
                if(this.puedeDisparar){
                    var martillo = this.grupoMartillos.getFirstDead();
                    if(martillo){
                        martillo.alive = true;
                        martillo.x = this.prota.x;
                        martillo.y = this.prota.y;
                        martillo.body.velocity.y = -200;
                        martillo.body.angularVelocity = this.rnd.between(200, 500);
                        martillo.body.velocity.x = this.rnd.between(-25, 25)
                        if(GGJ.haySonido){
                            this.sonido_disparo.play();
                        } 
                    } 
                    this.puedeDisparar = false;
                    this.time.events.add(this.tiempoEntreDisparos, function(){
                        //console.log("ya puedes")
                        this.puedeDisparar=true;
                    },this)
                }            
            }, this);
        }else{
            this.pad = this.game.plugins.add(Phaser.VirtualJoystick);
            this.stick = this.pad.addStick(160, this.world.height-75, 75, 'arcade');
            this.stick.scale = 0.5;
            //this.stick.showOnTouch = true;

            this.botonArcade = this.pad.addButton(this.game.world.width-150, this.world.height-75, 'arcade', 'button1-up', 'button1-down');
            this.botonArcade.scale = 0.5;
            this.botonArcade.onDown.add(function(){
                if(this.puedeDisparar){
                    var martillo = this.grupoMartillos.getFirstDead();
                    if(martillo){
                        martillo.alive = true;
                        martillo.x = this.prota.x;
                        martillo.y = this.prota.y;
                        martillo.body.velocity.y = -200;
                        martillo.body.angularVelocity = this.rnd.between(200, 500);
                        martillo.body.velocity.x = this.rnd.between(-25, 25)
                        if(GGJ.haySonido){
                            this.sonido_disparo.play();
                        } 
                    } 
                    //this.puedeDisparar = false;
                    this.time.events.add(this.tiempoEntreDisparos, function(){
                        this.puedeDisparar=true;
                    },this)
                }
            },this)
        }
        
    },
	create: function () {
        /////////////////////////////////////////////////////////////////////////////////////////////////////
        GGJ.iconoAudio = this.game.add.sprite(this.world.width-45, this.world.height-25, "boton-sonido");
        GGJ.iconoAudio.anchor.setTo(0.5);
        GGJ.iconoAudio.inputEnabled = true;
        GGJ.iconoAudio.scale.setTo(0.5)
        GGJ.iconoAudio.input.useHandCursor = true;
        GGJ.iconoAudio.events.onInputDown.add(function(){
            GGJ.cambiaSonido();
        });
        /////////////////////////////////////////////////////////////////////////////////////////////////////
        GGJ.iconoMusica = this.game.add.sprite(45, this.world.height-25, "boton-musica");
        GGJ.iconoMusica.anchor.setTo(0.5);
        GGJ.iconoMusica.inputEnabled = true;
        GGJ.iconoMusica.scale.setTo(0.5)
        GGJ.iconoMusica.input.useHandCursor = true;
        GGJ.iconoMusica.events.onInputDown.add(function(){
            GGJ.cambiaMusica();
        });

        GGJ.chequeaSonidos();
        if(GGJ.hayMusica){
            GGJ.bso.play();
            GGJ.iconoMusica.frame=0;
        }else{
            GGJ.iconoMusica.frame=1;
        }

        if(GGJ.haySonido){
            GGJ.iconoAudio.frame=0;
        }else{
            GGJ.iconoAudio.frame=1;
        }
        this.gritoPapa = this.game.add.bitmapText(this.world.centerX, this.world.centerY, 'fuente-normal',"", 28)
        this.gritoPapa.anchor.setTo(0.5)
        this.gritoPapa.align = "center"
        if(this.game.device.desktop){
            this.sacaGritoPapa("Hit me if you can, kid...\n(SPACEBAR to fire and\nCURSORS to move)")
        }else{
            this.sacaGritoPapa("Hit me if you can, kid...\n(BUTTON to fire and\nJOYSTICK to move)")
        }
        this.initBolasPajaros();
        this.initPajaros();        
	},
    reseteaMartillo:function(martillo){
        martillo.alive = false;
        martillo.x = -100;
        martillo.y = 0;
        martillo.body.velocity.y = martillo.body.velocity.x = 0;
        martillo.body.angularVelocity = 0;
    },
    reseteaBala:function(bala){
        bala.alive = false;
        bala.x = -100;
        bala.y = -50;
        bala.body.velocity.y = bala.body.velocity.x = 0;
        bala.body.acceleration.y = bala.body.acceleration.x = 0;
    },
    fxTintSprite:function(sprite){
        this.game.time.events.add(100, function(){
            sprite.tint = 0xf39e9e;
        },this)
        this.game.time.events.add(150, function(){
            sprite.tint = 0xd11e1e;
        },this)
        this.game.time.events.add(200, function(){
            sprite.tint = 0xf39e9e;
        },this)
        this.game.time.events.add(250, function(){
            sprite.tint = 0xd11e1e;
        },this)
        this.game.time.events.add(300, function(){
            sprite.tint = 0xFFFFFF;
        },this)
    },
    fxHammertime:function(donde){
        this.hammertime.x = donde.x;
        this.hammertime.y = donde.y;
        this.hammertime.animations.play("baila", 5, true)

        var texto = this.game.add.bitmapText(donde.x, donde.y, "fuente-normal", "HAMMER TIME!", 28)
        texto.anchor.setTo(0.5)
        this.time.events.add(750, function(){
            var salida1 = this.game.add.tween(this.hammertime).to({y:-100}, 250, Phaser.Easing.Quintic.Out, true);
            var salida2 = this.game.add.tween(texto).to({y:this.world.height+50}, 250, Phaser.Easing.Quintic.Out, true);
            salida2.onComplete.add(function(){
                texto.destroy();
            },this)

        }, this)
        if(GGJ.haySonido){
            this.sonido_hammertime.play();
        }
    },
    martillazo:function(papa, martillo){
        this.fxTintSprite(this.papa)
        this.fxTintSprite(this.cabeza)
        this.martillazos++;
        this.papaVulnerable=false;
        this.game.time.events.add(500, function(){
            this.papaVulnerable = true
        },this)
        this.fxHammertime(martillo)
        this.screenFlash.flash(0.75)
        this.tiempoEntreDisparos*=1.5;
        this.desvanecePapa();
        this.gritoPapa.setText("")
        this.reseteaMartillo(martillo);
        if(this.martillazos==1){
            this.corazonesArriba.frame=2
            this.timerPajaros.start();
            this.sacaGritoPapa("RELEASE THE KRAKEN!");
            this.cabeza.scale.setTo(0.4)
        }else if(this.martillazos==2){
            this.corazonesArriba.frame=1
            this.cabeza.scale.setTo(0.25)
            this.sacaGritoPapa("OK, let´s start playing...\nI´m gonna smash you!")
        }else if(this.martillazos==3){
            this.corazonesArriba.frame=0
            GGJ.hasGanado=true;
            this.detenJuego();            
        }
    },
    revientaPajaro:function(martillo, pajaro){
        if(pajaro.y>0){
            this.screenFlash.flash(0.75)
            this.reseteaBala(pajaro);
            if(GGJ.haySonido){
                this.sonido_impacto_recibido.play();
            }
        }
    },
    balazo:function(prota, bala){
        this.fxTintSprite(this.prota)
        this.vidasRestantes--;
        this.juicy.shake();
        this.reseteaBala(bala);


        if(this.vidasRestantes==2){
            this.corazonesAbajo.frame=2
        }else if(this.vidasRestantes==1){
            this.corazonesAbajo.frame=1
        }else if(this.vidasRestantes==0){
            this.corazonesAbajo.frame=0 
            GGJ.hasGanado=false;
            this.detenJuego();          
        }


        if(GGJ.haySonido){
            this.sonido_impacto_recibido.play();
        }
    },
    botellazo:function(prota, bala){
        this.vidasRestantes=0;
        this.juicy.shake();
        this.reseteaBala(bala);
        this.detenJuego();
    },


    
    desvanecePapa:function(){        
        var animacion = this.game.add.tween(this.papa).to({y:-100}, 300, Phaser.Easing.Elastic.Out, true);
        var bombaHumo = this.game.add.sprite(this.papa.x, this.papa.y, "bomba-humo")
        bombaHumo.anchor.setTo(0.5)
        this.papa.y = -500;
        this.cabeza.y = -500;
        animacion.onComplete.add(function(){
            var posX;
            var posY;
            if(this.papa.x < this.world.centerX){
                posX = this.rnd.between(this.world.centerX, this.world.width-100)
            }else{
                posX = this.rnd.between(100, this.world.centerX)     
            }
            this.papa.x = this.cabeza.x = posX; 
            if(this.martillazos==1){
                posY = this.world.height*0.225
            }else if(this.martillazos==2){
                posY = this.world.height*0.2;
            }
            var vuelta = this.game.add.tween(this.papa).to({y:posY}, 100, Phaser.Easing.Quintic.Out, true, 1000);
            var vueltaCabeza = this.game.add.tween(this.cabeza).to({y:posY}, 100, Phaser.Easing.Quintic.Out, true, 1000);
        }, this);
        bombaHumo.animations.add("splash", [0, 1, 2, 3, 4, 5])
        bombaHumo.animations.play("splash", 10, false, true)
        bombaHumo.anchor.setTo(0.5)
    },
    update: function () {
        if(this.juegoActivo){
            this.prota.body.velocity.x = 0;
            if(this.game.device.desktop){
                if(this.izquierda.isDown && !this.derecha.isDown){
                    this.prota.animations.play("izquierda", 15, true)
                    this.prota.body.velocity.x = -100;
                }else if(!this.izquierda.isDown && this.derecha.isDown){
                    this.prota.animations.play("derecha", 15, true)
                    this.prota.body.velocity.x = 100;
                }
                if(this.izquierda.isUp && this.derecha.isUp){
                    this.prota.animations.stop();
                    this.prota.frame=0;
                    this.prota.body.velocity.x = 0;
                }
            }else{
                if (this.stick && this.stick.isDown){
                    this.physics.arcade.velocityFromRotation(this.stick.rotation, this.stick.force * 100, this.prota.body.velocity);
                    this.prota.body.velocity.y = 0;
                    if(this.prota.body.velocity.x  < 0){
                        this.prota.animations.play("izquierda", 15, true)
                    }else if(this.prota.body.velocity.x  > 0){
                        this.prota.animations.play("derecha", 15, true)
                    }
                    this.stick.motionLock = Phaser.VirtualJoystick.HORIZONTAL;
                }else{
                    this.prota.animations.stop();
                    this.prota.frame=0;
                }
            }


            

            this.physics.arcade.collide(this.prota, this.paredIzquierda); 
            this.physics.arcade.collide(this.prota, this.paredDerecha);
            if(this.papaVulnerable){
                this.physics.arcade.overlap(this.cabeza, this.grupoMartillos, this.martillazo, null, this);     
            }
            
            this.physics.arcade.overlap(this.prota, this.grupoBalas, this.balazo, null, this); 
            this.physics.arcade.overlap(this.prota, this.grupoBotellas, this.botellazo, null, this); 
            this.physics.arcade.overlap(this.prota, this.grupoBolasPajaros, this.balazo, null, this); 
            this.physics.arcade.overlap(this.prota, this.grupoPajaros, this.botellazo, null, this);
            this.physics.arcade.overlap(this.grupoMartillos, this.grupoPajaros, this.revientaPajaro, null, this); 

            this.cabeza.x = this.papa.x;

            this.grupoMartillos.forEachAlive(function(martillo){
                if(martillo.y < -50){
                    this.reseteaMartillo(martillo);
                }
            },this)

            this.grupoBalas.forEachAlive(function(bala){
                if(bala.y > this.world.height+30){
                    this.reseteaBala(bala);
                }
            },this)

            this.grupoBotellas.forEachAlive(function(botella){
                if(botella.y > this.world.height+30){
                    this.reseteaBala(botella);
                }
            },this)

            this.grupoBolasPajaros.forEachAlive(function(bola){
                if(bola.y > this.world.height+30){
                    this.reseteaBala(bola);
                }
            },this)

            var fecha = new Date();
            this.momentoActual = fecha.getTime();
            this.tiempoJugado = (this.momentoActual - this.momentoInicio);

            if(this.pasosParaActualizar==5){
                GGJ.puntuacion = this.tiempoJugado;
                var tiempoFormateado = this.formateaTiempo(this.tiempoJugado)
                this.marcador.setText(tiempoFormateado);
                this.pasosParaActualizar=0;          
            }else{
               this.pasosParaActualizar++
           }
        }else{
            if(this.papa && this.cabeza){
                this.cabeza.x = this.papa.x;
            }
        }
    },
    detenJuego:function(){
        this.juegoActivo = false;
        this.timerPapa.stop();
        this.izquierda = null;
        this.derecha = null;
        this.espacio = null;
        this.prota.body.velocity.x = 0;
        this.prota.frame = 0;
        this.prota.animations.stop();
        this.cabeza.x = this.papa.x;
        this.cabeza.y = this.papa.y;
        this.grupoBalas.destroy();
        this.grupoMartillos.destroy();
        if(this.stick){
            this.stick.y = -5000;
            //this.stick.destroy();
        }
        if(this.pad){
            this.pad.y = -5000;
            //this.pad.destroy();
        }
        if(this.botonArcade){
            this.botonArcade.y = -5000;
            this.botonArcade.destroy();
        }

        if(GGJ.hasGanado){
            this.sacaMensajeVictoria();
        }else{
            this.sacaGritoPapa("HAHAHA! God bless\nyour tiny hammer.");

            this.time.events.add(3000, function(){
                this.game.state.start("Rankings")
            },this)
        }
    },
    sacaGritoPapa:function(mensaje){
        this.gritoPapa.alpha = 0;
        this.gritoPapa.setText(mensaje)
        var aparicion = this.game.add.tween(this.gritoPapa).to({alpha:1} ,500, Phaser.Easing.Quintic.Out, true);
        aparicion.onComplete.add(function(){
            var desaparicion = this.game.add.tween(this.gritoPapa).to({alpha:0} ,500, Phaser.Easing.Quintic.Out, true, 3000);    
        }, this) 
    },
    sacaMensajeVictoria:function(){
        var arrayMensajes = [
        "Suck it,\npope!",
        "God bless\nmy hammer",
        "Where is\nGod now?",
        "MONESVOL\nsent me",
        "You pay the\nbeers, loser",
        "Ramen,\nbrother"
        ]
        var grupoMensaje = this.game.add.group();
        var bocadillo = this.game.add.sprite(this.prota.x, this.prota.y-30, "bocadillo");
        bocadillo.anchor.setTo(0.5, 1)
        grupoMensaje.add(bocadillo);

        var mensaje = this.game.add.bitmapText(bocadillo.x, bocadillo.y-50, 'fuente-comentarios',arrayMensajes[this.rnd.between(0, arrayMensajes.length-1)], 16)
        mensaje.align="left";
        mensaje.anchor.setTo(0.5)
        grupoMensaje.add(mensaje)
        grupoMensaje.alpha=0;

        var aparicion = this.game.add.tween(grupoMensaje).to({alpha:1} ,500, Phaser.Easing.Quintic.Out, true);
        aparicion.onComplete.add(function(){
            var desaparicion = this.game.add.tween(grupoMensaje).to({alpha:0} ,500, Phaser.Easing.Quintic.Out, true, 5000);
            desaparicion.onComplete.add(function(){
                this.game.state.start("Rankings")
            }, this)
        },this)
        
    },
    render:function() {
        //this.game.debug.body(this.prota);        
        //this.game.debug.spriteCorners(sprite, true, true);
    }
};